
-- apply a function to all list elements (predefined as `map'):
map_ ::  (a->b) -> [a] -> [b]

map_ _ []      = []
map_ f (x:xs)  = f x : map_ f xs

-- accumulate all list elements (predefined as `foldr'):
foldr_ ::  (a->b->b) -> b -> [a] -> b

foldr_ _ z []     = z
foldr_ f z (h:t)  = f h (foldr_ f z t)

-- sum of squares:
goal xs = SLICE (foldr_ (+) 0 (map_ (\x->x*x) xs))

bench = let r free in goal [1..60000] =:= r

SLICE x = x
