
-- apply a function to all list elements (predefined as `map'):
map_ ::  (a->b) -> [a] -> [b]

map_ _ []      = []
map_ f (x:xs)  = f x : map_ f xs


-- function composition:
comp :: (a->b) -> (c->a) -> c -> b
comp f g x = f (g x)


-- beyond higher-order macros:
iter f n = if n==0 then f else iter (comp f f) (n-1)

goal x = SLICE (map_ (iter (+1) 2) x)

bench = let r free in goal [1..20000] =:= r

SLICE x = x
